/*

CITLDed_Sample.c

Copyright (C) 2020  Lineo Solutions, Inc.

*/


#include <stdio.h>
#include "CITLFunc.h"

#define TARGET_ADDR	16384
#define COUNT_MAX	5


unsigned short gData = 0;	/* Count Data */

/* Called Function from CPU module */
void func(unsigned short* pusReqData, unsigned short* pusReqSize, unsigned short* pusAnsData, unsigned short* pusAnsSize){
	short sRet = 0;
	
	sRet = CITL_ToBuf(TARGET_ADDR, 1, &gData, 0);
	printf("CITL_ToBuf Executed sRet = %d\n", sRet);
	gData++;
	
	return ;
}

int main(void){
	short sRet = 0;
	
	CITLAppInit();
	
	/* Entry function */
	sRet = CITL_EntryDedicatedInstFunc((CITL_CEXECUTEFUNCPTR)func);
	printf("CITL_EntryDedicatedInstFunc Executed sRet = %d\n", sRet);
	if(sRet != 0){
		return -1;
	}
	
	/* if gData exceeds COUNT_MAX, this program is finished. */
	while(1){
		if(gData > COUNT_MAX){
			break;
		}
	}
	return 0;

}	

