/*

CITLFunc_Sample.c

Copyright (C) 2020  Lineo Solutions, Inc.

*/


#include <stdio.h>
#include "MDRFunc.h"

#define COMM_CH			12	/* Communication Channel(iQ-R Bus Access) */
#define COMM_TIMEOUT	100	/* Communication Timeout */

int main(void){
	short sRet = 0;
	long lPath = 0;
	long lSize = 0;
	short sData_W = 0;
	short sData_R = 0;
	
	mdrAppInit();
	
	/* Communication Channel Open */
	sRet = mdrOpen(COMM_CH, -1, &lPath, COMM_TIMEOUT);
	if(sRet != 0){
		printf("mdrOpen Failed %d\n", sRet);
		return -1;
	}
	
	/* Write Data to D0 */
	lSize = 2;
	sData_W = 0xFFFF;
	sRet = mdrSend(lPath, 4, 0, 0, 0, 0, DevD, 0, &lSize, &sData_W);
	if(sRet != 0){
		printf("mdrSend Failed %d\n", sRet);
		mdrClose(lPath);
		return -1;
	}
	
	/* Read Data from D0 */
	sRet = mdrReceive(lPath, 4, 0, 0, 0, 0, DevD, 0, &lSize, &sData_R);
	if(sRet != 0){
		printf("mdrReceive Failed %d\n", sRet);
		mdrClose(lPath);
		return -1;
	}
	
	printf("D0 = %d\n", sData_R);
	
	sRet = mdrClose(lPath);
	if(sRet != 0){
		printf("mdrClose Failed %d\n", sRet);
		return -1;
	}
	
	return 0;
}
